
// PIC16F18344 Configuration Bit Settings

// 'C' source line config statements

// CONFIG1
#pragma config FEXTOSC = OFF    // FEXTOSC External Oscillator mode Selection bits (Oscillator not enabled)
#pragma config RSTOSC = EXT1X   // Power-up default value for COSC bits (EXTOSC operating per FEXTOSC bits)
#pragma config CLKOUTEN = OFF   // Clock Out Enable bit (CLKOUT function is disabled; I/O or oscillator function on OSC2)
#pragma config CSWEN = ON       // Clock Switch Enable bit (Writing to NOSC and NDIV is allowed)
#pragma config FCMEN = ON       // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is enabled)

// CONFIG2
#pragma config MCLRE = OFF      // Master Clear Enable bit (MCLR/VPP pin function is digital input; MCLR internally disabled; Weak pull-up under control of port pin's WPU control bit.)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config WDTE = OFF       // Watchdog Timer Enable bits (WDT disabled; SWDTEN is ignored)
#pragma config LPBOREN = OFF    // Low-power BOR enable bit (ULPBOR disabled)
#pragma config BOREN = OFF       // Brown-out Reset Enable bits (Brown-out Reset enabled, SBOREN bit ignored)
#pragma config BORV = LOW       // Brown-out Reset Voltage selection bit (Brown-out voltage (Vbor) set to 2.45V)
#pragma config PPS1WAY = ON     // PPSLOCK bit One-Way Set Enable bit (The PPSLOCK bit can be cleared and set only once; PPS registers remain locked after one clear/set cycle)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable bit (Stack Overflow or Underflow will not cause a Reset)
#pragma config DEBUG = OFF      // Debugger enable bit (Background debugger disabled)

// CONFIG3
#pragma config WRT = OFF        // User NVM self-write protection bits (Write protection off)
#pragma config LVP = OFF         // Low Voltage Programming Enable bit (Low Voltage programming enabled. MCLR/VPP pin function is MCLR. MCLRE configuration bit is ignored.)

// CONFIG4
#pragma config CP = OFF         // User NVM Program Memory Code Protection bit (User NVM code protection disabled)
#pragma config CPD = OFF        // Data NVM Memory Code Protection bit (Data NVM code protection disabled)

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

#include <xc.h>

#define A7 RC0
#define B7 RC1
#define C7 RC2
#define D7 RC3
#define E7 RC4
#define F7 RC5
#define G7 RC6
#define DP7 RC7
#define D1 RB4
#define D3 RB5
#define D2 RB6
#define D4 RB7
#define B1 RA0
#define B2 RA1

#define CLOCK //Or Snake
/*
 * File:   newmain.c
 * Author: Comp
 *
 * Created on 3 ?????? 2023 ?., 21:58
 */
#define _XTAL_FREQ 4000000

#include <xc.h>



void init(void);
void show( char symbol, char razr);
void Shownumb(char pol, char fig);
void clockwise(void);
void antickockwise(void);
void showdp(void);
char second =0;
volatile char spin;		//??????????? ???????? 0 ?? ???????, 1 - ??????
char minuts, hours;

void main(void)
 {
spin = 0;
minuts= 54;
hours= 0;
init();			//????????????? ?????????

while(1)



 {
  

#ifdef Snake

if(spin) clockwise();
	else antickockwise();


#endif



#ifdef CLOCK
		Shownumb(0,minuts);
		showdp();
		Shownumb(1,second);

	if(second==60)
		{second=0;
		minuts++;
		}
	if(minuts==60)
	{
	minuts=0;
	hours++;
	}
	if(hours==24)hours=0;		
#endif


}

}



void __interrupt() function(void)		//??????????
 {

	if(TMR1IF&&TMR1IE)			//?????????? ?? ??????? ???????? ??? ? 1 ???.
{
TMR1IF=0;						//????? ?????
 second++;
//IOCIE = 1;
}
	if(IOCIE&&IOCIF)
	{IOCIF = 0;					//????? ?????
	if(B2 == 0) {(hours++ == 24)? (hours =0):NOP();spin ^= 1;}
	if(B1 == 0){minuts++==60? (minuts=0):NOP();spin ^= 1;}
	IOCAF1 =0;
    IOCAF0 = 0;

	}
    return;
}







void init(void)
{	
	#ifdef CLOCK
        OSCCON1=0b01110011;
        SOSCPWR = 1;
	#else
    OSCCON1=0b01101001;
	#endif
	 //all outputs except RA0  - i.e. 1 - input or 0 - output
//	OPTION_REG = 0;

	ANSELA =0;
	ANSELB =0;
    ANSELC =0;
    TRISA = 0b00110011;
    
 	WPUA1=1;
 	WPUA0=1;
    TRISB = 0;      // outputs
	TRISC = 0;
	PORTB = 0;
	PORTC =0;
//---------------------Timer1----------------------------
	T1CON=0b11000101;	//Timer1 is on and 1:8 prescaler
     
	//	------------------Interrupton on the change of edge

     IOCAN0 =1;
 IOCAN1 =1;
	IOCIE = 1;			//?????????? ?? ??????
	TMR1IE = 1;			//?????????? ?? ?????? 1
 	PEIE = 1;
	GIE = 1;			//Global Interrupt enable*/
}

void show( char symbol, char razr)

{	

	A7 = 0;
	B7 = 0;
	C7 = 0;
	D7 = 0;
	E7 = 0;
	F7 = 0;
	G7 = 0;
	DP7 = 0;
	switch(razr)
	{case 1:
	D1 = 1;
	D2 = 0;
	D3 = 0;
	D4 = 0;
	break;
 	case 2:
	D1 = 0;
	D2 = 1;
	D3 = 0;
	D4 = 0;
	break;
	case 3:
	D1 = 0;
	D2 = 0;
	D3 = 1;
	D4 = 0;
	break;
	case 4:
	D1 = 0;
	D2 = 0;
	D3 = 0;
	D4 = 1;
	break;
	}
	
	switch(symbol)
	{

	case 0:
	A7 = 1;
	B7 = 1;
	C7 = 1;
	D7 = 1;
	E7 = 1;
	F7 = 1;
	break;
	case 1:
	B7 = 1;
	C7 = 1;
	break;
	case 2:
	A7 = 1;
	B7 = 1;
	G7 = 1;
	D7 = 1;
	E7 = 1;
	break;
	case 3:
	A7 = 1;
	B7 = 1;
	C7 = 1;
	D7 = 1;
	G7 = 1;
	break;
	case 4:
	B7 = 1;
	C7 = 1;
	G7 = 1;
	F7 = 1;
	break;
	case 5:
	A7 = 1;
	G7 = 1;
	C7 = 1;
	D7 = 1;
	F7 = 1;
	break;
	case 6:
	A7 = 1;
	G7 = 1;
	C7 = 1;
	D7 = 1;
	E7 = 1;
	F7 = 1;
	break;
	case 7:
	A7 = 1;
	B7 = 1;
	C7 = 1;
	break;
	case 8:
	A7 = 1;
	B7 = 1;
	C7 = 1;
	D7 = 1;
	E7 = 1;
	F7 = 1;
	G7 = 1;
	break;
	case 9:
	A7 = 1;
	B7 = 1;
	C7 = 1;
	D7 = 1;
	F7 = 1;
	G7 = 1;
	break;
	}

}


void Shownumb(char pol, char fig)

{ switch(pol)
	{case 0:
	show(fig/10,4);
	show(fig%10,3);
	break;
	case 1:
	show(fig/10,2);
	show(fig%10,1);
	break;
	}
return;
}

void showdp(void)

{DP7 = 1;
D3=1;
}




void clockwise(void)
	{F7=0;
	A7 = 1;
	D4 = 1;
	_delay(5000);
	D4 = 0;
	D3 = 1;
	_delay(5000);
	D3=0;
	D2=1;
_delay(5000);
	D2=0;
	D1=1;
_delay(5000);	
	A7=0;
	B7=1;
_delay(5000);
	B7=0;
	C7=1;
	_delay(5000);
	C7=0;
	D7=1;
	_delay(5000);
	D1=0;
	D2=1;
	_delay(5000);
	D2=0;
	D3=1;
	_delay(5000);
	D3=0;
	D4=1;
	_delay(5000);
	D7=0;
	E7=1;
	_delay(5000);
	E7=0;
	F7=1;
	_delay(5000);

}

void antickockwise(void)

{ 	D4=1;			
	F7=1;
	A7=0;
	_delay(500);
	F7 = 0;
	E7 = 1;
	_delay(500);
	E7	=	0;
	D7	=	1;
_delay(500);
	D4 = 0;
	D3 = 1;
_delay(500);
	D3 = 0;		
	D2 = 1;				
	_delay(500);
	D2 = 0;
	D1 = 1;
	_delay(500);		
	D7 = 0;	
	C7 = 1;
	_delay(500);	
	C7 = 0;
	B7 = 1;
_delay(500);
	B7 = 0;	
	A7 = 1;	
_delay(500);	
	D1=0;	
	D2=1;	
_delay(500);
	D2=0;
	D3=1;
_delay(500);
	D3=0;
	D4=1;
_delay(500);
}
